/* data.h
 * Copyright (C) 2001 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef DATA_H
#define DATA_H 1

#include "ipaddress.h"
#include "macaddress.h"
#include "timestamp.h"
#include "list.h"
#include "network.h"
#include "machine.h"
#include "interface.h"
#include "device.h"
#include "subnet.h"
#include "visual.h"

class Data
{
	public:
		Data();
		~Data();

		void empty();
		void savexml(char *fname);
		void loadxml(char *fname);
		void print();

		void machineToDev(Machine *m);
		void deleteMachinesMatchingIP(IPAddress *ip);
		Device *find_ip_on_device(IPAddress tip);
		void select(char val);
//		void hide_leaf_networks();
		void size();
		void sizeshow();
		int selected_size();
		void set_leaves();
		void hide();
		void bunch(Visual *cur, int sel);
		void buncha(Device *r, int sel);
		void group_all(char ch);
		void star(Visual *cur, int sel);
		int  is_network_a_leaf(Network *n);
		void stara(Device *r, int sel);
		void group_machines();
		void apply_group();
		void show_all();
		void del_device(Device *d);
		void position_links();

		List machines;
		List networks;
		List subnets;
		List devices;
		long width, height;
		long minx, miny;
		char show_leaves;
		char default_view[65];
};

#endif

